local frame_size_default = {180, 16}
local updelapsed = 1
local cevmoffset = -2
local cevday = -1
local cevindex = -1
local cevcount = -1
local seek_events = 0
local frame_id = 0
HALLOWTIMER_CALENDAR_UPDATE_RANGE = 6
local calendar_updating = false
local events = {


}
local evb = {}
local eve = {}
local depth1 = 0
local execqueue = nil

--[[
Returns a%b
]]
HallowTimer_Modulo = function(a, b)
	return a-(floor(a/b)*b)
end

--[[
Gets the number of days in a month
Takes:
  month, year
]]
HallowTimer_GetNumberOfDays = function(month, year)
	if month == 1 or month == 3 or month == 5 or month == 7 or month == 8 or month == 10 or month == 12 then
		return 31
	elseif month == 2 then
		if HallowTimer_Modulo(year, 4) == 0 then
			if HallowTimer_Modulo(year, 100) == 0 then
				if HallowTimer_Modulo(year, 400) == 0 then
					return 29
				else
					return 28
				end
			else
				return 29
			end
		else
			return 28
		end
	elseif month == 4 or month == 6 or month == 9 or month == 11 then
		return 30
	end
end

local months = {
	30, 31, 30, 31,
	31, 29, 31,
	[0] = { 2015, 9 }
}

local ela = 0
local hr, min = GetGameTime()
local sec = 0
local weekday, month, day, year = CalendarGetDate()
local main_p = 0
local short_p = 0
local vshort_p = 0
local configversion = "2.0.1a"
local versionnotices = 20001
local default = {420, 280}
local longtime = 7
local shorttime = 1
local vshorttime = 1/12
localstimer = function()
	return startday, shortday, shorthour, vshortday, vshorthour, vshortmin, eventday, eventhour, eventmin, day, hr, min, sec, main_p, short_p, vshort_p, "|||", weekday, month, day, year, hr, min,  sec
end


local offset = 5/12



for k, v in pairs(events) do
	if v[6] then
		eve[v[1]] = k
		v[5][1] = events[evb[v[1]]][5][4]
		v[5][2] = events[evb[v[1]]][5][3]
		v[5][3] = events[evb[v[1]]][5][2]
		v[5][4] = events[evb[v[1]]][5][1]
		v[5][4][4] = 1
	else
		evb[v[1]] = k
	end
	if v[7] == nil then v[7] = 0 end
end

--if (year == 2015 and
--month == 10 and
--day >= startday and day <= eventday) or (hr == -1 and min == -1) then

local h3 = CreateFont("HallowTimerH3")
h3:SetFont("Fonts\\FRIZQT__.TTF", 11)
local h2 = CreateFont("HallowTimerH2")
h2:SetFont("Fonts\\FRIZQT__.TTF", 12)
local timeframe = CreateFrame("SIMPLEHTML", nil, UIParent)
timeframe.dfmt = "<p>|H%{EVENT_ID}|h|cffffa000%{EVENT_NAME}|r|h in:<br />|cffffff00|r%{DAYSD}%{HOURS}:%{MINS}</p>"
timeframe.fmt = timeframe.dfmt
timeframe.texture = timeframe:CreateTexture()
timeframe.texture:SetTexture(0, 0, 0, 0.5)
timeframe.texture:SetAllPoints(timeframe)
timeframe:SetFontObject(h3)
timeframe:SetFont("Fonts\\FRIZQT__.TTF", 11)
timeframe:SetText(timeframe.fmt)
timeframe:Hide()
timeframe.sticky = 0
timeframe:SetHyperlinksEnabled(true)
timeframe:SetScript("OnHyperlinkClick", function(self, link, text, btn)
	--print("TARGET", link)
	local target = link--:gsub("_+_", "'")
	--if btn == "LeftButton" then
		if target ~= "0" then
			glob_pos_hallowtimer.w = target
		else
			glob_pos_hallowtimer.w = nil
		end
	--end
	timeframe.sticky = 0
	timeframe:Hide()
end)
timeframe:SetHeight(200)
localshl =  function()
	print(timeframe:GetHyperlinksEnabled())
end

--[[
Gets month and year based on the offset from current month
]]
local HallowTimer_GetMonthFromOffset =  function(o)
	local m = month + o
	local y = year
	while m > 12 do
		y = y + 1
		m = m - 12
	end
	while m < 1 do
		y = y - 1
		m = m + 12
	end
	return m, y
end


local HallowTimer_Queue = function(fnc, ...) --------------------------------------------- QUEUE EXECUTION
	if execqueue ~= nil then--[[
		glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = "QUEUE FULL!!!!!!!!!!"]]
		error("EXECUTION QUEUE FULL, frame_id = ".. frame_id)
	end
	execqueue = {fnc, {...}}--[[
	glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = "queue"]]
end
local HallowTimer_SeekNextEvent = function() ------------------------------------------------------------- SEARCH THE CALENDAR FOR EVENTS
	--[[glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = "SeekNextEvent"]]
	if seek_events > 0 then
	seek_events = 2
	--print("SeekNextEvent") -- TODO: Remove
	local weekday, month, day, year = CalendarGetDate();
--[[	glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {"CalendarGetDate", weekday, month, day, year, "CalendarSetAbsMonth"}]]
	CalendarSetAbsMonth(month, year);
	if cevcount ~= -1 then
		if cevcount == cevindex then
			cevcount = -1
		else
			cevindex = cevindex + 1
			--print("Opening: ", cevmoffset, cevmday, cevindex, cevcount) -- TODO: Remove
			CalendarSetAbsMonth(HallowTimer_GetMonthFromOffset(cevmoffset))
			CalendarOpenEvent(0, cevmday, cevindex)--[[
			glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {0, cevmday, cevindex, "CalendarOpenEvent"}]]
			return
		end
	end
	while cevcount == -1 do
		if cevmoffset == -2 then
			cevmoffset = -1
			cevmday = -1
		end
		if cevmday > 31 then
			cevmoffset = cevmoffset + 1
			cevmday = -1
			if cevmoffset > HALLOWTIMER_CALENDAR_UPDATE_RANGE then
				cevcount = -1
				cevmoffset = -2
				seek_events = 0
				glob_hallowtimer.last_update = year .. month
				print("|cff00ffffFESTIVALTIMER|r Update finished")--[[
				glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {"BeginUpdateBar", "Queue"}]]
				HallowTimer_Queue(HallowTimer_BeginUpdateBar)
				return
			end
		end
		if cevmday == -1 then
			if cevmoffset == -1 then
				cevmday = day - 1
			else
				cevmday = 0
			end
			cevcount = -1
		end
		cevmday = cevmday + 1
		CalendarSetAbsMonth(HallowTimer_GetMonthFromOffset(cevmoffset))
		local tempcnt = CalendarGetNumDayEvents(0, cevmday)--[[
		glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {0, cevmday, "CalendarGetNumDayEvents", tempcnt }]]
		--print("CalendarGetNumDayEvents", tempcnt, cevmoffset, cevmday)
		if tempcnt > 1 then
			cevcount = tempcnt
			cevindex = 1
			--print("Opening: ", cevmoffset, cevmday, cevindex, cevcount) -- TODO: Remove
			CalendarSetAbsMonth(HallowTimer_GetMonthFromOffset(cevmoffset))
			CalendarOpenEvent(0, cevmday, cevindex)--[[
			glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {0, cevmday, cevindex, "CalendarOpenEvent" }]]
			return
		end
	end
	end
end

--[[
Gets a list of upcoming events within the next x days with same numeration as on the global list
]]
HallowTimer_GetUpcomingEvents = function(x)
	--print("upcoming") -- TODO: REMOVE
	local upc = {}
	local current = { year = year, month = month, day = day, hour = hr, minute = min }
	for k, v in pairs(glob_hallowtimer.events) do
		local diff =  HallowTimer_GetEventTimeDiff(current, v)
		if diff < x and diff > 0 then
			upc[k] = v
		end
	end
	return upc
end

--[[
Gets the list of events currently registered into HallowTimer. The list can be updated.
]]
HallowTimer_GetAllEvents = function()
	return glob_hallowtimer.events
end

--[[
Gets the beginning event of the specific ending event
Returns:
  event
  number on list
 or
  nil if unable to find the beginning (ie. single-day event)
]]
HallowTimer_GetBeginOf = function(ev)
	local n = -1
	if ev.sequence ~= "END" then
		return nil
	end
	for k, v in pairs(glob_hallowtimer.events) do
		if HallowTimer_CompareEvents(ev, v) then
			--print("Compared")
			n = k
			--print(n)
			for i = n-1, 1, -1 do
				--print(i, n)
				if ev.title == glob_hallowtimer.events[i].title and ev.type == glob_hallowtimer.events[i].type and ev.caltype == glob_hallowtimer.events[i].caltype then
					--print("match")
					return glob_hallowtimer.events[i], i
				end
			end
			return nil
		end
	end
	return nil
end

--local clui

--[[
Starts the update of HallowTimer calendar
]]
HallowTimer_UpdateCalendar = function()
	local clui = Calendar_LoadUI
	Calendar_LoadUI =  function(...)
		if seek_events ~= 0 then
			print("|cff00ffffFESTIVALTIMER|r Calendar opened, UI broken! Please reload UI")
			seek_events = 0
			glob_hallowtimer.last_update = nil
			glob_hallowtimer.events = {}
			
			StaticPopupDialogs["HALLOWTIMER_BROKEN_UI"] = {
				text = "The calendar has been opened while FestivalTimer has been updating event database and the UI needs to be reloaded.",
				button1 = "Reload",
				button2 = "Later",
				OnAccept = function()
					ReloadUI()
				end,
				timeout = 0,
				whileDead = true,
				hideOnEscape = true,
				preferredIndex = 3
			}
			StaticPopup_Show("HALLOWTIMER_BROKEN_UI")
		end
		clui(...)
	end
	print("|cff00ffffFESTIVALTIMER|r Updating event database, please wait...")
	updelapsed = 0
	seek_events = 1
	local weekday, month, day, year = CalendarGetDate();
	CalendarSetAbsMonth(month, year);
	OpenCalendar()
end

--[[
Compares two events in HallowTimer format
Takes:
  ev1, ev2 = events to compare
Returns:
  true or false
]]
HallowTimer_CompareEvents = function(ev1, ev2)
	return (ev1.title == ev2.title) and (ev1.year == ev2.year) and (ev1.month == ev2.month) and (ev1.day == ev2.day) and (ev1.hour == ev2.hour) and (ev1.minute == ev2.minute) and (ev1.sequence == ev2.sequence) and (ev1.type == ev2.type) and (ev1.caltype == ev2.caltype)
end

--[[
Returns the difference in time (in days) between two events. The value may be non-integer and negative (if the first argument occurs later than the second)
]]
HallowTimer_GetEventTimeDiff = function(ev1, ev2, stop)
	if stop == nil then stop = 600 end
	--print("diff") -- TODO: REMOVE
	if ev1 == nil or ev2 == nil then
		return -10000
	end
	local cm, cy, diff = ev1.month, ev1.year, 0
	--print(cm, cy, diff)
	while cm < ev2.month or cy < ev2.year do
		diff = diff + HallowTimer_GetNumberOfDays(cm, cy)
		if diff > stop + 1 then
			--return stop
		end
		cm = cm + 1
		if cm == 13 then
			cm = 1
			cy = cy + 1
		end
	end
	while cm > ev2.month or cy > ev2.year do
		if diff < -stop - 1 then
			--return -stop
		end
		cm = cm - 1
		if cm == 0 then
			cm = 12
			cy = cy - 1
		end
		diff = diff - HallowTimer_GetNumberOfDays(cm, cy)
	end
	diff = diff + ev2.day - ev1.day
	diff = diff + (ev2.hour - ev1.hour) / 24
	diff = diff + (ev2.minute - ev1.minute) / 24 / 60
	return diff
end


local frame = CreateFrame("FRAME", "HallowTimerFrame", UIParent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST")
frame:RegisterEvent("CALENDAR_UPDATE_EVENT")
frame:RegisterEvent("CALENDAR_OPEN_EVENT")
frame:SetScript("OnEvent", function(self, event, ...)
	depth1 = depth1 + 1
	if event == "ADDON_LOADED" and ... == "HallowTimer" then
	frame:SetMovable(true)
	frame:EnableMouse(true)
	if glob_pos_hallowtimer == nil then
		glob_pos_hallowtimer = {x = default[1], y = default[2], c = "reset", d = default, s = frame_size_default}
	end
	if glob_pos_hallowtimer.c == "restore" then
		glob_pos_hallowtimer.x = glob_pos_hallowtimer.r[1]
		glob_pos_hallowtimer.y = glob_pos_hallowtimer.r[2]
		glob_pos_hallowtimer.s = glob_pos_hallowtimer.r.s
		glob_pos_hallowtimer.r = nil
		glob_pos_hallowtimer.c = configversion
		glob_hallowtimer = glob_pos_hallowtimer.r.ht
		print("Previous configuration has been restored. You can reset to the default configuration using the '/hallowtimer reset' command")
	end
	if glob_pos_hallowtimer.c ~= "1.0.1" and glob_pos_hallowtimer.c:sub(1, 2) ~= "2." then
		local restore = {glob_pos_hallowtimer.x, glob_pos_hallowtimer.y, s = {glob_pos_hallowtimer.s[1], glob_pos_hallowtimer.s[2]}, ht = glob_hallowtimer}
		local cause = glob_pos_hallowtimer.c == "reset" and "HallowTimer configuration reset " or "Old configuration version "
		glob_pos_hallowtimer = {x = default[1], y = default[2], c = configversion, r = restore, d = default}
		glob_hallowtimer = { events = {}, colorprog = { 1, 1, 1, 1 }, colorempty = { 0, 0, 0, 1 }, match_enabled = true, match = { "Hallow's End", "Anniversary", "Pilgrim's Bounty", "Winter Veil", "Lunar Festival", "Love is in the Air", "Noblegarden", "Children's Week", "Midsummer Fire Festival", "Harvest Festival", "Brewfest" } }
		print(cause .. " has been detected and will be overwritten. You can restore the last configuration using the '/hallowtimer restore' command")
	end
	if glob_pos_hallowtimer.c ~= configversion then
		glob_hallowtimer.last_update = nil
		glob_hallowtimer.events = {}
	end
	if glob_pos_hallowtimer.c == "1.0.1" then
		glob_hallowtimer = { events = {}, colorprog = { 1, 1, 1, 1 }, colorempty = { 0, 0, 0, 1 }, match_enabled = true, match = { "Hallow's End", "Anniversary", "Pilgrim's Bounty", "Winter Veil", "Lunar Festival", "Love is in the Air", "Noblegarden", "Children's Week", "Midsummer Fire Festival", "Harvest Festival", "Brewfest" } }
		glob_pos_hallowtimer.c = configversion
	end
	if glob_pos_hallowtimer.s == nil then
		glob_pos_hallowtimer.s = frame_size_default
	end
	if glob_pos_hallowtimer.ver ~= versionnotices then
		glob_pos_hallowtimer.ver = versionnotices
		StaticPopupDialogs["HALLOWTIMER_VERSION_NOTICE"] = {
			text = "Welcome to FestivalTimer |cffff80002.0.1a|r!\nYou can now customize the color of the bar by entering:\n/fest color fg (red) (green) (blue)\n/fest color bg (red) (green) (blue)\nExample: /fest color fg 1 1 0 - the left side of the bar will become yellow\n\nUse the left mouse button to move the bar.\nRight-click the bar to make the popup sticky so you can choose which event to track by clicking its name.\nMiddle-click the bar to make the popup appear at the bottom or top.\n\nThe bar will not appear unless there is a major world event upcoming in 7 days (ex. Hallow's End, Lunar Festival).\n\nAlso, please do not open the calendar window while the event database updates.",
			button1 = "Ok",
			timeout = 0,
			whileDead = true,
			hideOnEscape = true,
			preferredIndex = 3
		}
		StaticPopup_Show("HALLOWTIMER_VERSION_NOTICE")
	end
	glob_pos_hallowtimer.c = configversion
	self:SetUserPlaced(false)
	self:ClearAllPoints()
	self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", glob_pos_hallowtimer.x, glob_pos_hallowtimer.y)
	self:SetSize(glob_pos_hallowtimer.s[1], glob_pos_hallowtimer.s[2])
	self:SetWidth(glob_pos_hallowtimer.s[1])
	self:SetHeight(glob_pos_hallowtimer.s[2])
	if glob_pos_hallowtimer.fb ~= 1 then
		timeframe:SetPoint("BOTTOMLEFT", "HallowTimerFrame", "TOPLEFT")
		timeframe:SetPoint("BOTTOMRIGHT", "HallowTimerFrame", "TOPRIGHT")
	else
		timeframe:SetPoint("TOPLEFT", "HallowTimerFrame", "BOTTOMLEFT")
		timeframe:SetPoint("TOPRIGHT", "HallowTimerFrame", "BOTTOMRIGHT")
	end
	--[[
	if glob_hallowtimer.frames == nil then
		glob_hallowtimer.frames = {}
	end
	]]
	end
	--[[
	if glob_hallowtimer.frames[frame_id] == nil then
		glob_hallowtimer.frames[frame_id] = {}
	end
	glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = {event, ..., seek_events = seek_events}
	]]
	if event == "PLAYER_LOGIN" then
		--self:Hide()
		weekday, month, day, year = CalendarGetDate()
		hr, min = GetGameTime()
		self:SetUserPlaced(false)
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", glob_pos_hallowtimer.x, glob_pos_hallowtimer.y)
	end
	if event:match("CALENDAR") then
		--print("-", event, seek_events, depth1) -- TODO: Remove
	end
	if event == "CALENDAR_UPDATE_EVENT_LIST" then ------------------------------------------------------------ UPDATE THE CALENDAR
		if seek_events == 1 then
			seek_events = 2
			--print("List updated") -- TODO: Remove
			if glob_hallowtimer == nil then
				glob_hallowtimer = {events = {}}
			end
			for k, v in pairs(glob_hallowtimer.events) do
				v.confirmed = 0
			end
			HallowTimer_Queue(HallowTimer_SeekNextEvent)
		end
		depth1 = depth1 - 1
		return
	end
	if --[[event == "CALENDAR_UPDATE_EVENT" or]] event == "CALENDAR_OPEN_EVENT" --[[or event == "CALENDAR_UPDATE_EVENT_LIST"]] then ----------------------------------------------------------------- GET THE FOUND EVENT
		if seek_events == 2 then
			--print("Found event") -- TODO: Remove
			--if CalendarEventGetCalendarType() == "ONGOING" then
			--	depth1 = depth1 - 1
			--	return
			--end
			
			local current_event = {}
			local current_event_day = {CalendarGetDayEvent(0, cevmday, cevindex)}
			--for k, v in pairs(current_event) do
				--print(k, v)
			--end
			current_event.title = current_event_day[1]
			current_event.day = cevmday
			current_event.month, current_event.year = HallowTimer_GetMonthFromOffset(cevmoffset)
			current_event.hour = current_event_day[2]
			current_event.minute = current_event_day[3]
			current_event.caltype = current_event_day[4]
			current_event.sequence = current_event_day[5]
			current_event.type = current_event_day[6]
			current_event.countdown = 7
			local begin, _ = HallowTimer_GetBeginOf(current_event)
			if begin ~= nil then
				current_event.countdown = HallowTimer_GetEventTimeDiff(begin, current_event)
			end
			local inlist = 0
			
			if current_event.sequence == "START" then
				current_event.name = current_event.title .. " begins"
			elseif current_event.sequence == "END" then
				current_event.name = current_event.title .. " ends"
			elseif current_event.caltype == "RAID_LOCKOUT" or current_event.caltype == "RAID_RESET" then
				current_event.name = current_event.title .. " resets"
			else
				current_event.name = current_event.title
			end
			
			if current_event.sequence ~= "ONGOING" then
				for k, v in pairs(glob_hallowtimer.events) do
					if HallowTimer_CompareEvents(v, current_event) then
						inlist = 1
						v.confirmed = 1
						break
					end
				end
				if inlist == 0 then
					glob_hallowtimer.events[#glob_hallowtimer.events+1] = current_event
				end
			--	print("INLIST", inlist) -- TODO: Remove
			end--[[
			glob_hallowtimer.frames[frame_id][#glob_hallowtimer.frames[frame_id]+1] = current_event
			]]
			HallowTimer_Queue(HallowTimer_SeekNextEvent)
		end
		depth1 = depth1 - 1
		return
	end
	if event:match("CALENDAR") then
		--print("+", event, seek_events, depth1) -- TODO: Remove
	end
	depth1 = depth1 - 1
end)

HallowTimer_PrintSeekEvents = function()
	print(seek_events)
end

HallowTimer_MatchesCountdownName = function(e)
	if glob_hallowtimer.match_enabled == false then return true end
	for k, v in pairs(glob_hallowtimer.match) do
		if e.title:match(v) then
			return true
		end
	end
	return false
end

--[[
Begins the bar updates
]]
HallowTimer_BeginUpdateBar = function()
	frame:SemiShow()
end

HallowTimer_GetCountdownEvents = function()
--	print("countdown") -- TODO: REMOVE
	local upc = {}
	local current = { year = year, month = month, day = day, hour = hr, minute = min }
	--print(current.year, current.month)
	for k, v in pairs(glob_hallowtimer.events) do
		local diff =  HallowTimer_GetEventTimeDiff(current, v)
		if v.countdown ~= nil and diff < v.countdown and diff > 0 and HallowTimer_MatchesCountdownName(v) then
			upc[k] = v
		end
	end
	return upc
end

HallowTimer_TableDump = function(t)
	local text = "{"
	for k, v in pairs(t) do
		text = text .. " [\"" .. k .. "\"] = "
		if type(v) == "table" then
			text = text .. HallowTimer_TableDump(v)
		else
			text = text .. v
		end
		text = text .. ", "
	end
	text = text .. "}"
end

frame.hidden = 1
frame.texture = frame:CreateTexture()
frame.texture:SetTexture(0, 0.2, 1, 0.5)
frame.texture:SetAllPoints(frame)
frame.short = CreateFrame("FRAME", nil, frame)
frame.short.texture = frame.short:CreateTexture()
frame.short.texture:SetTexture(0, 1, 0.2, 1)
frame.short.texture:SetAllPoints(frame.short)
frame.short.vshort = CreateFrame("FRAME", nil, frame.short)
frame.short.vshort.texture = frame.short.vshort:CreateTexture()
frame.short.vshort.texture:SetTexture(1, 0, 0, 1)
frame.short.vshort.texture:SetAllPoints(frame.short.vshort)
frame.short.vshort.tend = CreateFrame("FRAME", nil, frame.short.vshort)
frame.short.vshort.tend.texture = frame.short.vshort.tend:CreateTexture()
frame.short.vshort.tend.texture:SetTexture(0, 0, 0, 1)
frame.short.vshort.tend.texture:SetAllPoints(frame.short.vshort.tend)
frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 100, -100)
frame.short:SetPoint("TOP", frame, "TOP")
frame.short:SetPoint("LEFT", frame, "LEFT")
frame.short:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short.vshort:SetPoint("TOP", frame, "TOP")
frame.short.vshort:SetPoint("LEFT", frame, "LEFT")
frame.short.vshort:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short.vshort.tend:SetPoint("TOP", frame, "TOP")
frame.short.vshort.tend:SetPoint("LEFT", frame, "LEFT")
frame.short.vshort.tend:SetPoint("BOTTOM", frame, "BOTTOM")
frame.short:SetWidth(15)
frame:Show()
frame:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" then
		self:StartMoving()
	end
	if button == "RightButton" then
		timeframe.sticky = (timeframe.sticky == 1 and 0 or 1)
	end
	if button == "MiddleButton" then
		glob_pos_hallowtimer.fb = (glob_pos_hallowtimer.fb == 1 and 0 or 1)
		timeframe:ClearAllPoints()
		if glob_pos_hallowtimer.fb ~= 1 then
			timeframe:SetPoint("BOTTOMLEFT", "HallowTimerFrame", "TOPLEFT")
			timeframe:SetPoint("BOTTOMRIGHT", "HallowTimerFrame", "TOPRIGHT")
		else
			timeframe:SetPoint("TOPLEFT", "HallowTimerFrame", "BOTTOMLEFT")
			timeframe:SetPoint("TOPRIGHT", "HallowTimerFrame", "BOTTOMRIGHT")
		end
	end
	--print("DOWN")
end)
frame:SetScript("OnHide", function(self, btn)
	timeframe:Hide()
end)
frame.SemiHide = function(self)
	frame.hidden = 1
	frame:Show()
	frame:SetAlpha(0) -- TODO: Set to 0
end
frame.SemiShow = function(self)
	frame.hidden = 0
	frame:Show()
	frame:SetAlpha(1)
end
frame:SetScript("OnMouseUp", function(self, btn)
	--print("UP")
	self:StopMovingOrSizing()
	glob_pos_hallowtimer.x = self.GetLeft(self)
	glob_pos_hallowtimer.y = self.GetTop(self)
	self:SetUserPlaced(false)
end)
frame:SetScript("OnEnter", function(self, mot)
	if self.hidden == 0 then
		timeframe:Show()
	end
	--print(mot)
end)
frame:SetScript("OnLeave", function(self, mot)
	if timeframe.sticky == 0 then timeframe:Hide() end
	--print(mot)
end)
function GetTimePercentage(sd, sh, sm, ss, ed, eh, em, es, cd, ch, cm, cs)
	local starttime = ((ss / 60 + sm) / 60 + sh) / 24 + sd
	local curtime   = ((cs / 60 + cm) / 60 + ch) / 24 + cd
	local endtime   = ((es / 60 + em) / 60 + eh) / 24 + ed
	local p = (curtime - starttime) / (endtime - starttime)
	if p < 0 then p = 0 end
	if p > 1 then p = 1 end
	return p
end
		
local function clamp(v)
	if v < 0  then
		return 0
	end
	if v > 1 then
		return 1
	end
	return v
end

local function is_before(cm, ct, em, et)
	return ((ct <= et + 1/3600/24 and cm == em) or (cm < em))
end
local function is_after(cm, ct, em, et)
	return ((ct >= et and cm == em) or (cm > em))
end
local function add_days(m, t, days)
	local cm = m
	local cd = t + days
	while days >= months[cm - months[0][1]*12 - months[0][2] + 1]+1 do
		cd = cd - months[cm - months[0][1]*12 - months[0][2] + 1]
		cm = cm + 1
	end
	return cm-m, cd-t
end

HallowTimer_GetPreviousMonth = function(m, y)
	if m == 1 then
		return 12, y-1
	else
		return m-1, y
	end
end
HallowTimer_GetNextMonth = function(m, y)
	if m == 12 then
		return 1, y+1
	else
		return m+1, y
	end
end


		

frame:SetScript("OnUpdate", function(self, elapsed)
	frame_id = frame_id + 1--[[
	glob_hallowtimer.frames[frame_id] = {}
	]]
	if execqueue ~= nil then
		local exq = execqueue
		execqueue = nil
		exq[1](unpack(exq[2]))
		return
	end
	--self:SetMovable(true)
	if updelapsed == 2 then
		if year .. month ~= glob_hallowtimer.last_update then
			HallowTimer_UpdateCalendar()
		else
			HallowTimer_BeginUpdateBar()
		end
	end
	if updelapsed == 1 then
		updelapsed = 2
	end

--	if self.hidden == 0 then
		ela = ela + elapsed

		local awaiting = {}
		local nextevent =nil
		local cmd = 0
		local pmd = 0
		local nmd = 0
		cmd = HallowTimer_GetNumberOfDays(month, year)
		local pm, nm = 0, 0
		pmd = HallowTimer_GetNumberOfDays(HallowTimer_GetPreviousMonth(month, year))
		nmd = HallowTimer_GetNumberOfDays(HallowTimer_GetNextMonth(month, year))
		local cm = year * 12 + month
		local ct = day + hr / 24 + min / 24 / 60 + sec / 24 / 3600
		local em = 0
		local et = 0
		local shm = 0
		local sht = 0
		local vsm = 0
		local vst = 0
		local sm, st
		local nextevent_a
		for k, v in pairs(HallowTimer_GetCountdownEvents()) do

			if tonumber(glob_pos_hallowtimer.w) == k then
				nextevent = v
				break
			end
			
			if HallowTimer_GetEventTimeDiff(nextevent, v) < 0 then
				nextevent = v
			end
			
		end
		--]] -- TODO: REMCOMMENT
		if nextevent == nil then self:SemiHide() end
		sec = sec + elapsed
		if sec >= 60 then
			min = min + 1
			sec = sec - 60
			if min >= 60 then
				hr = hr + 1
				min = min - 60
				if hr >= 24 then
					day = day + 1
					hr = hr - 24
					if day > cmd then
						month = month + 1
						day = day - cmd
						if month >= 13 then
							year = year + 1
							month = month - 12
						end
					end
				end
			end
		end
		local ctm, stm, etm, shtm, vstm
		----[[ TODO: REMCOMMENT
		if nextevent ~= nil then

			ctm = {
				day = day,
				month = month,
				year = year,
				hour = hr,
				minute = min
			}
			etm = nextevent
			main_p   = clamp(((nextevent.countdown-HallowTimer_GetEventTimeDiff(ctm, nextevent))/nextevent.countdown))   --GetTimePercentage(startday, 0, 0, 0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
			short_p  = clamp((shorttime-HallowTimer_GetEventTimeDiff(ctm, nextevent))/shorttime) --GetTimePercentage(shortday, shorthour, 0,        0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
			vshort_p = clamp((vshorttime-HallowTimer_GetEventTimeDiff(ctm, nextevent))/vshorttime) --GetTimePercentage(vshortday,vshorthour,vshortmin,0, eventday, eventhour, eventmin, 0, day, hr, min, sec)
			if short_p > main_p then short_p = main_p end
			if vshort_p > short_p then vshort_p = short_p end
		--print(stm)
			frame.texture:SetTexture(unpack(glob_hallowtimer.colorempty))
			frame.short.texture:SetTexture(unpack(glob_hallowtimer.colorprog))
			frame.short.vshort.texture:SetTexture(1, 1, 1, 0)
				frame.short.vshort.tend.texture:SetTexture(1, 1, 1, 0)

		
			frame.short:SetWidth(main_p * glob_pos_hallowtimer.s[1])
			frame.short.vshort:SetWidth(short_p * glob_pos_hallowtimer.s[1])
			frame.short.vshort.tend:SetWidth(vshort_p * glob_pos_hallowtimer.s[1])
			frame.short:Show()
			frame.short.vshort:Show()
			frame.short.vshort.tend:Show()
			if day ~= 0 then
			if main_p == 0 then
				frame.short:Hide()
			end
			if short_p == 0 then
				frame.short.vshort:Hide()
			end
			if vshort_p == 0 then
				frame.short.vshort.tend:Hide()
			end

			local text = "<html><body>"
			if timeframe.sticky == 0 then
			--timeframe:SetHeight(100 + (#awaiting * 34 + (glob_pos_hallowtimer.w and 11 or 0)))
			timeframe:SetHeight(timeframe:GetContentHeight())
			--timeframe:Clear()
			for k, v in pairs(HallowTimer_GetCountdownEvents()) do
			--if ctm < etm or v.id ~= nextevent then
				local sf = "%02d"
				local timetill = HallowTimer_GetEventTimeDiff(ctm, v)
				local t = { EVENT_NAME = v.name,
						 EVENT_NAME_BR = v.name:gsub("%\\", "<br />"), 
						 DAYS = math.floor((timetill)), 
						 HOURS = string.format(sf, math.floor(((timetill) - math.floor((timetill))) * 24)),
						 MINS = string.format(sf, math.floor(((timetill)* 24 - math.floor((timetill)* 24)) * 60)),
						 SECS = string.format(sf, math.floor(((timetill)* 24 * 60 - math.floor((timetill)* 24 * 60)) * 60)),
						 EVSE = "error",
						 EVENT_ID = k,
						 EVENT_ENDING = v.sequence == "ENDING" and 1 or 0 }
				t.DAYSD = t.DAYS == 0 and "" or string.format("%sd, ", t.DAYS)
				local textn = timeframe.fmt:gsub("%%\{([A-Z_]*)\}", function(arg)
					return t[arg]
				end)
				--timeframe:AddMessage(textn)
				timeframe:SetHyperlinksEnabled(true)
				text = text .. textn
				--timeframe:Hide()
				--timeframe:Show()
			--end
			end
			if glob_pos_hallowtimer.w then
				--timeframe:AddMessage("|H0|h|cffff0000Reset|r|h")
				text = text .. ("<p>|H0|h|cffff0000Reset|r|h</p>")
			end
				if timeframe:IsVisible() then
				timeframe:Hide()
				timeframe:Show()
				end
			text = text .. "</body></html>"
			--timeframe:SetHyperlinksEnabled(false)
			timeframe:SetText(text)
			end

			end
			local tempmin
			_, tempmin = GetGameTime()
			if (tempmin) > (min) and (tempmin - min <= 2) then
				sec = 0
				min = tempmin
			end
		end
		--]] -- TODO: REMCOMMENT
		if ela > 1 then
			ela = 0
			--print ("NEVENT", nextevent, "CT", ctm, "ST", stm, "ET", etm, "MAIN", main_p, "SHORT", short_p, "VSH", vshort_p)
		end
--	else
--		timeframe:SetText("Content not yet ready")
--	end
end)


SLASH_HALTIM1 = "/hallowtimer"
SLASH_HALTIM2 = "/fest"
SlashCmdList.HALTIM = function(arg, ...)
	if arg == "reset" then
		glob_pos_hallowtimer.c = "reset"
		ReloadUI()
	elseif arg == "restore" then
			glob_pos_hallowtimer.c = "restore"
			ReloadUI()
	elseif arg:match("^color") then
		local c, r, g, b = arg:match("^color (%w+) ([0-9%.]+) ([0-9%.]+) ([0-9%.]+)")
		if c == nil or r == nil or g == nil or b == nil then
			print("Use |cffffff00/fest help|r for help.")
			return
		end
		if c == "fg" then
			glob_hallowtimer.colorprog = {r, g, b, 1}
		elseif c == "bg" then
			glob_hallowtimer.colorempty = {r, g, b, 1}
		end
	else
			print("Usage: /fest reset - Restores the default configuration")
			print("Usage: /fest restore - Restores the configuration from before reset")
			print("Usage: /fest color fg |cffffff00red green blue|r - Sets the color of the bar's left side")
			print("Usage: /fest color bg |cffffff00red green blue|r - Sets the color of the bar's right side")
			print("Usage: Right-click the bar and then click the event name or reset button to make the bar indicate time until the selected or the nearest event")
	end
end--[[

HallowTimer_Debug_SaveFrames = function()
	glob_hallowtimer.frames_s = glob_hallowtimer.frames
end
]]




--end